% concrete logic program to run represented as facts.
prog(inc(e,b1(e))).
prog(inc(b0(M),b1(M))).
prog(imp(inc(M,N), inc(b1(M),b0(N)))).

prog(q(99)).
prog(r(5555)).
prog(imp(or(q(X),r(X)), p(X))).

% inc itself is an atomic proposition.
atm(inc(_M,_N)).
atm(q(_)).
atm(r(_)).


% solve(+G) solve goal G using prog/1 program

solve(G) :- display(G), nl, fail.

solve(true).
solve(and(G1,G2)) :-
    solve(G1),
    solve(G2).
solve(or(G1,_G2)) :- solve(G1).
solve(or(_G1,G2)) :- solve(G2).
solve(P) :- atm(P), prog(D), focus(D, P).

focus(Q,P) :- atm(Q), unify_with_occurs_check(Q,P).
focus(imp(G,D),P) :- focus(D,P), solve(G).

